#include <gstPHANToM.h>
#include <gstDeviceIO.h>
#include "..\opengl.h"
unsigned int p_layout[5];
array<float> *blend10,*blend50;
float P_enable_rotz=1;
#include "..\aniava.h"
#include "..\phantom.h"

linked<animated*> linked_ani;
phantom *P;
int P_closest=0,P_ready=1000,P_switch,P_paint=1,P_oldmode; //0=none,1=small,3=spray (2=onering)
float P_radius=3;

string *locat;

array<int> *rndb,*triList;
array<float> *vertices,*haptics,*rndu,*rndn,*vertreacd;
array<int> *triangles,*vertreach,*vertclose;
unsigned int colorcube;

matrix<float> *f_sty; //STYLUS: filter
matrix<float> *p_sty; //        phantom recording
matrix<float> *c_sty; //        convolution (test purpose)

matrix<float> *f_cir; //CIRCLE: filter
matrix<float> *p_cir; //        phantom recording
matrix<float> *c_cir; //        convolution (test purpose)

#include "include.cpp"

GST_SCHEDULER_CALLBACK servoLoop(void *null) {
	int c1,c2;
	P->std();
	phantom_haptics();
	P->force*=blend10->token(1)*blend50->token(1);
	if (P->force.norm()>4.3) P->force=P->force.normalize()*4.3;		
	gstSetPhantomForce(P->ghost,P->force);
	return 0;
};

void main_(int argc,char** argv) {
	int c1,c2,cnt=0,ofs;	
	if (argc!=2) {printf("\n!!!Please call executable with model location.\nYour models are located in the data folder.\nExample: prog dragon3"); exit(0);}	
	locat=new string;
	*locat=(string)("data\\")+(string)(argv[1]);
	printf("Retrieving model info in %s.*\n",locat->str);	
	rndb=new array<int>("data\\rndb.tab");		//random numbers
	rndu=new array<float>("data\\rndu.tab");
	rndn=new array<float>("data\\rndn.tab");	
	blend10=new array<float>("data\\blend10.tab");
	blend50=new array<float>("data\\blend50.tab");
	
	vertices=new array<float>((*locat+(string)(".cv")).str);   	//vertices=new array<float>("data\\d4.cv");	//file input                       
	triangles=new array<int>((*locat+(string)(".ind")).str);   	//triangles=new array<int>("data\\d4.ind");                                        
	triList=new array<int>((*locat+(string)(".vt")).str);      	//triList=new array<int>("data\\d4.vt");		//list of triangle indicees @ each vertex
	haptics=new array<float>((*locat+(string)(".hap")).str);   	//haptics=new array<float>("data\\d4.hap");	//inv(Tri) | vertex #3 | Tri-normal    
	
	vertreach=new array<int>(1,&vertices->size[1],0); //vertices for P_paint=2
	vertreacd=new array<float>(1,&vertices->size[1],0); //distance for P_paint=2
	vertclose=new array<int>(1,&vertices->size[1],0); //vertices for P_paint=3
	
	f_sty=new matrix<float>("data\\sty.fil");	//filters for recognition
	p_sty=new matrix<float>(f_sty->numel,1,"");
	c_sty=new matrix<float>(f_sty->numel,1,"");
	
	f_cir=new matrix<float>("data\\cir.fil");
	p_cir=new matrix<float>(f_cir->numel,1,"");
	c_cir=new matrix<float>(f_cir->numel/2,1,"");//
	
	avatar *A=new avatar();										//avatar init...
		A->mat->data[14]=25; 
		linked_ani.append(A);					
	
	camera *C=new camera();										//camera init...
		*C->mat=matrix<float>(4,4,"eye");
		C->mat->data[14]=47; //C->mat->data[14]=7;
		linked_ani.append(C);
		
	P=new phantom();													//phantom init...
		p_layout[0]=0;
		p_layout[1]=phantom_listGstPtr1(glGenLists(1));				
		p_layout[2]=phantom_listGstPtr2(glGenLists(1));
		p_layout[3]=phantom_listGstPtr3(glGenLists(1));
		p_layout[4]=phantom_listGstPtr4(glGenLists(1));		
		gstInitServoScheduler();
  	gstStartServoScheduling(servoLoop,NULL);
  	linked_ani.append(P);

	colorcube=listColorCube(25,glGenLists(1));//other init...
	glClearColor(.3,.3,.3,0);
};

void display_(void) {	
	int c1,c2,cnt;
	animated* ani;
	linked_ani.token(ani);
	ani->humanize();
	ani->invert();
	if (ani->index==ANI_AVATAR) P->mode=1;				
	else {
		P->mode=0;
		blend10->size[1]=0;
		P_paint=0;
		gstVector col=(P->pos+gstVector(2.5,2.5,2.5))*.2+gstVector(0,0,1.4);
		char glt[30];
		sprintf(glt,"(%3i,%3i,%3i)",int(255*col.x()),int(255*col.y()),int(255*col.z()));
		linked_label.append(new glLabelText(250,frame_h-100,glt,fnt0));		
		P->col[0]=col.x(); P->col[1]=col.y(); P->col[2]=col.z();
		glPushMatrix();
			glTranslatef(P->mat->data[12],P->mat->data[13],P->mat->data[14]);			
			glColor3f( 1, 1,1); glutWireCube(.31);		
			glColor3fv(P->col); glutSolidCube(.3);
			glColor3f(.7,.4,0); glLineWidth(1);	glBegin(GL_LINES);
				glVertex3f(-20,  0,  0); glVertex3f(0,0,0);
				glVertex3f(  0,-20,  0); glVertex3f(0,0,0);
				glVertex3f(  0,  0,-20); glVertex3f(0,0,0);
			glEnd();			
		glPopMatrix();
		if (P->button) P_switch=1;
	}
	P->master=ani; P->layout=p_layout[P_paint];
	if (stkey[  9]) P_switch=1;
	if (stkey[ 92]) P->layout=0; //hide phantom pointer (to make picture)
	if (stkey[115]) vertices->store((*locat+(string)(".cv")).str);	//file output	
	while (linked_ani.token(ani)) {
		ani->live();		
		if (ani->index==ANI_CAMERA&&P_switch) //very inelegant!!!
			if (!stkey[9]) {linked_ani.advance(); P_switch=0; P_oldmode=P_paint;}
		if (ani->index==ANI_AVATAR&&P_switch)
			if (!stkey[9]) {linked_ani.advance(); P_switch=0; P_paint=P_oldmode;}
					
		if (ani->index==ANI_BUBBLE) {
			if (ani->carrier) bubble_collide((bubble*)ani);			
		}
		if (toc>=ani->time[1]) {//death time reached
			if (ani->carrier) {   //switch ANI to delete carrier
				if (ani->index==ANI_BUBBLE) delete ani->carrier;					
			}
			delete ani; linked_ani.remove();
		}
	}	
	p_sty->record(P->sty.z());
	//p_cir->record(P->pos.x());p_cir->record(P->pos.y());
	//if (stkey[32]) {*f_cir=*p_cir;p_cir->store("cir.sig");}	
	phantom_closest(); 							//keps track of closest vertex
	phantom_signals(); 							//motion recognition
	if (P->button) phantom_paint();	//paint (reduces to spray)
	
	glCallList(colorcube);
	if (1) {//display model
		glEnableClientState(GL_VERTEX_ARRAY);
		glEnableClientState(GL_COLOR_ARRAY);
		glColorPointer(3,GL_FLOAT,6*4,vertices->data);		
		glVertexPointer(3,GL_FLOAT,6*4,&vertices->data[3]);
		glDrawElements(GL_TRIANGLES,triangles->numel,GL_UNSIGNED_INT,triangles->data);
		glDisableClientState(GL_VERTEX_ARRAY);
		glDisableClientState(GL_COLOR_ARRAY);
	}	
	if (0) {//axis
		glColor3f(.7,.4,0); glLineWidth(1);	glBegin(GL_LINES);
			glVertex3f(-20,  0,  0); glVertex3f( 20,  0,  0);
			glVertex3f(  0,-20,  0); glVertex3f(  0, 20,  0);
			glVertex3f(  0,  0,-20); glVertex3f(  0,  0, 20);	glEnd();}
	if (1) {//floor
		glColor3f(.4,.4,.4); glBegin(GL_QUADS);
			glVertex3f(-100,-80, 100);
			glVertex3f( 100,-80, 100);
			glVertex3f( 100,-80,-100);	
			glVertex3f(-100,-80,-100); glEnd();}	
}